/* Copyright (C) 2002 by SWsoft
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*  $Id: gen_rfc2396.c,v 1.2 2002/10/03 22:47:44 matt Exp $
*/

#include "aspseek-cfg.h"

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#include "defines.h"

#define RFC2396_ESCAPE_PATH	0x01
#define RFC2396_ESCAPE_QUERY	0x02

int main(int argc, char *argv[])
{
	unsigned c;
	BYTE flags;
	printf("/* this file is automatically generated by gen_rfc2396, do not edit */\n"
		"#define RFC2396_ESCAPE_PATH	0x%02x /* path escapes, as defined in RFC2396 */\n"
		"#define RFC2396_ESCAPE_QUERY	0x%02x /* query escapes, as defined in RFC2396 */\n\n",
		RFC2396_ESCAPE_PATH, RFC2396_ESCAPE_QUERY);
	printf("static const BYTE rfc2396_escapes[256] = {\n"
		"    0x00, ");
	for (c = 1; c < 256; ++c)
	{
		flags = 0;
		if (!isalnum(c) && !strchr("$-_.+!*'(),:@&=~/", c))
		{
			flags |= RFC2396_ESCAPE_PATH;
		}
		if (!isalnum(c) && !strchr("$-_.+!*'(),;/?:@&=~", c))
		{
			flags |= RFC2396_ESCAPE_QUERY;
		}
		printf("0x%02x%s", flags, (c < 255) ? ", " : "  ");
		if ((c % 8) == 7)
		{
			printf(" /*0x%02x...0x%02x*/\n    ", c-7, c);
		}
	}
	printf("\n};\n");
	exit(0);
}
